<template>
    <input type="text"
           v-bind:value="formattedDate"
           v-on:input="dateData = $event.target.value"
           readonly="readonly"
           placeholder="YYYY-MM-DD"/>
</template>

<script type="text/ecmascript-6">
    import DateConverter from "./../helpers/DateConverter";

    export default {
        name: "NepaliDatePicker",
        props: {
            uniqueid: {
                type: String,
                required: true,
            },
            type: {default: "day"},
            value: {default: ""},
        },
        data() {
            return {
                dateData: this.value,
                config: {
                    day: {
                        dateFormat: "yy-mm-dd",
                        closeOnDateSelect: true,
                    },
                },
            };
        },
        computed: {
            formattedDate() {
                if (this.dateData == null || this.dateData.length < 1) {
                    return this.dateData;
                }

                return this.dateData;
            },
        },
        watch: {},
        mounted: function() {
            let _self = this;
            $(`#${this.$el.id}`).nepaliDatePicker({
                dateFormat: "%y-%m-%d",
                closeOnDateSelect: true,
            });
            $(`#${this.$el.id}`).on("dateSelect", function(event) {
                window.Bus.$emit("bsDate", {"adDate": event.datePickerData.adDate, "uniqueid": _self.uniqueid, "type": _self.type});
                _self.$emit("input", event.datePickerData.formattedDate);
            });

            window.Bus.$on("adDate", this.updateDateFromEvent);
        },
        methods: {
            updateDateFromEvent(data) {

                if (data.uniqueid === this.uniqueid && data.date.length > 0) {
                    let dateConverter = new DateConverter;
                    let splitDate = data.date.split("-");
                    let bsDate = dateConverter.getBsDateByAdDate(parseInt(splitDate[0]), parseInt(splitDate[1]), parseInt(splitDate[2]));
                    this.dateData = `${bsDate.bsYear}-${bsDate.bsMonth}-${bsDate.bsDate}`;
                    this.$emit("input", this.dateData);
                }
            },
        },
    };
</script>

<style scoped>

</style>
